`timescale 1ns/1ns

//Timer0 Module

module mTimer0(reset,clk,Q,opt,wr_timer,datin,datout,deb);
	input reset,clk;
	input Q;		//Status
	input [3:0] opt;	//Lower 4bit of OPTION reg.
	input wr_timer;
	input [7:0] datin;
	output [7:0] datout;
	output [7:0] deb;
	reg [7:0] pcount;
	reg [7:0] tcount;
	wire countup;
	assign deb={4'h0,wr_timer,countup,Q,clk};	//pcount;
	
	assign datout=tcount;
	assign countup=((opt[3])||((opt[2:0]==3'h0)&&(pcount[0]))||((opt[2:0]==3'h1)&&(pcount[1:0]==2'h3))||((opt[2:0]==3'h2)&&(pcount[2:0]==3'h7))||
		((opt[2:0]==3'h3)&&(pcount[3:0]==4'hf))||((opt[2:0]==3'h4)&&(pcount[4:0]==5'h1f))||((opt[2:0]==3'h5)&&(pcount[5:0]==6'h3f))||
		((opt[2:0]==3'h6)&&(pcount[6:0]==7'h7f))||((opt[2:0]==3'h7)&&(pcount[7:0]==8'hff))) ? 1'b1 : 1'b0;
	
	//PreScaler
	always @(posedge clk or posedge reset) begin
		if(reset) begin
			pcount<=8'h00;
		end else if(Q) begin
			if(wr_timer)
				pcount<=8'h00;
			else
				pcount<=pcount+1'b1;
		end
	end
	
	
	//Timer0
	always @(posedge clk or posedge reset) begin
		if(reset) begin 
			tcount<=8'h00;
		end else begin
			if(Q) begin
				if(wr_timer) begin
					tcount<=datin;
				end else if(countup) begin
					tcount<=tcount+1'b1;
				end
			end
		end
	end
endmodule
